-- Vinny Loader by David Down
-- coding: utf-8
import "Turbine.Gameplay"

function print(text) Turbine.Shell.WriteLine("<rgb=#00FFFF>VL:</rgb> "..text) end
function printe(text) print("<rgb=#FF6040>Error: "..text.."</rgb>") end

VL_Opt = Turbine.PluginData.Load(Turbine.DataScope.Server,"VinnyLoader_Opt")
if not VL_Opt then VL_Opt = {auto=true} end
import "Vinny.VinnyLoader.VL_Window"
VL_window = VL_Window()
if VL_Opt then
	if not VL_Opt.auto then VL_window:SetVisible( false ) end
	if VL_Opt.pos1 then
		local x,y = VL_window:GetPosition()
		if y>VL_Opt.pos1.y then
			VL_window:SetPosition(VL_Opt.pos1.x,VL_Opt.pos1.y)
		end
	end
	if VL_Opt.add then
		for i,name in ipairs(VL_Opt.add) do
			local t = pFind(AP,name)
			if t then VL_window:Add(t) end
		end
	end
end
print("Vinny Loader initialized.")

function VL_Add(name)
	local t = pFind(AP,name)
	if not t then printe(name.." not found.") return end
	for i,vp in ipairs(VP) do
		if vp.f==name then printe(name.." already added.") return end
	end
	VL_window:Add(t)
	if not VL_Opt.add then VL_Opt.add = {} end
	table.insert(VL_Opt.add,name)
	Turbine.PluginData.Save(Turbine.DataScope.Server,"VinnyLoader_Opt",VL_Opt)
end

VL_Command = Turbine.ShellCommand()

function VL_Command:Execute( command,args )
    if command=="vl" then
		local vis = not VL_window:IsVisible()
		VL_window:SetVisible(vis)
		print("Window "..(vis and "displayed" or "hidden"))
		return
	end
	VL_Add(args)
end

function VL_Command:GetHelp()
	return "vl : Toggles VL window visibility\
vla <plugin> : Add the plugin to the window"
end

function VL_Command:GetShortHelp()
	VL_Command:GetHelp()
end

Turbine.Shell.AddCommand( "vl;vla", VL_Command )

-- Options panel
import "Vinny.Common.Options"
OP = Vinny.Common.Options_Init(print,VL_Opt,VL_window,"VinnyLoader_Opt")

local Small = Vinny.Common.Options_Box(OP,30," Use small icons")
if VL_Opt.small then Small:SetChecked(true) end
Small.CheckedChanged = function( sender, args )
	VL_Opt.small = sender:IsChecked()
	print((VL_Opt.small and "En" or "Dis").."abled small icons.")
	Turbine.PluginData.Save(Turbine.DataScope.Server,"VinnyLoader_Opt",VL_Opt)
end
